package spiel;

import java.util.Random;

public class Spielfeld {

	/*
	 * Diese Matrix stellt unser Spielfeld dar. Sie beinhaltet ints welche für
	 * Gegner oder Schatz stehen. 0 - Umgebung ,1 - Monster, 2 - Schatz, 3 Held
	 */
	private int[][] spielfeld;
	/*
	 * Damit das Spiel ein wenig was her macht, wollen wir für die verschiedenen
	 * Elemente Bilder darstellen
	 */
	private String pfad_zu_SpielfeldBild = "spielfeld.gif";
	private String pfad_zu_GegnerBild = "gegner.gif";
	private String pfad_zu_SchatzBild = "schatz.gif";
	private String pfad_zu_HeldBild = "held.gif";

	/*
	 * Diese beiden Variablen stehen für die aktuelle Position unserer
	 * Spielfigur in unserem Spielfeld
	 */
	int pos_x = 0;
	int pos_y = 0;

	/*
	 * Diese beiden Variablen stehen für die Position des Schatzes welcher
	 * geborgen werden soll - Sie werden automatisch generiert
	 */
	int pos_x_schatz;
	int pos_y_schatz;

	/*
	 * Diese Variable steht für die Anzahl der Gegner auf dem Feld
	 */
	int maxGegnerAnzahl = 5;

	/*
	 * Score
	 */
	private int score = 0;

	public Spielfeld() {
		/*
		 * Füge hier die Initialisierung unseres Spielfeldes ein zb. spielfeld =
		 * new int[10][10]; ist dies getan, soll das Array mit Werten gefüllt
		 * werden (Gegner) Danach soll die Position des Schatzes gewählt werden.
		 */
		spielfeld = new int[10][10];
		pos_x = 0;
		pos_y = 0;
		spielFeldAufbauen();
	}

	/*
	 * Implementiere die Funktionen zum Navigieren
	 */
	public void geheNachRechts() {

		if (pos_x + 1 != spielfeld[0].length) {
			unset_AlteHeldPosition(pos_y, pos_x);

			// TODO Hier soll die variable pos_x so geändert werden , dass nach
			// rechts gegangen wird.

			
			
			//

			set_HeldPostition();
		}
	}

	public void geheNachLinks() {
		if (pos_x - 1 != -1) {
			unset_AlteHeldPosition(pos_y, pos_x);
			// TODO Hier soll die variable pos_x so geändert werden , dass nach
			// links gegangen wird.

			
			
			//
			 set_HeldPostition();
		}
	}

	public void geheNachOben() {
		if (pos_y - 1 != -1) {
			unset_AlteHeldPosition(pos_y, pos_x);
			//TODO Hier soll die variable pos_x so geändert werden , 
			//dass nach oben gegangen wird.
			
			
			
			//
			set_HeldPostition();
		}
	}

	public void geheNachUnten() {
		if (pos_y + 1 != spielfeld.length) {
			unset_AlteHeldPosition(pos_y, pos_x);
			//TODO Hier soll die variable pos_x so geändert werden , 
			//dass nach unten gegangen wird.
			
			
			
			//
			set_HeldPostition();
		}
	}

	/*
	 * Hilfestellung
	 */

	private void spielFeldAufbauen() {

		/*
		 * IN DEM ABSCHNITT WIRD DER Held GESETZT
		 */
		set_HeldPostition();
		/*
		 * IN DEM ABSCHNITT WERDEN DIE GEGNER GESETZT
		 */
		set_GegnerPosition();
		/*
		 * Funktion um Schatz zu setzen wird aufgerufen
		 */
		set_SchatzPosition();
	}

	/*
	 * HILFSFUNKTIONEN -- NICHT INTERESSANT
	 */
	private void set_SchatzPosition() {
		boolean set = false;
		while (!set) {
			Random rand = new Random();
			int y = rand.nextInt(spielfeld.length);
			int x = rand.nextInt(spielfeld[0].length);
			if (spielfeld[y][x] != 3) {
				spielfeld[y][x] = 2;
				set = true;
			}
		}
	}

	private void set_GegnerPosition() {
		int gegnerAnzahl = 0;
		for (int y = 0; y < getSpielfeld().length; y++)
			for (int x = 0; x < getSpielfeld()[y].length; x++) {
				if (gegnerAnzahl < maxGegnerAnzahl)
					/*
					 * Damit die Gegner verteilt sind werden sie nur in der
					 * Chance 1/10 erzeugt
					 */
					if (new Random().nextInt(10) == 1) {
						if (!(spielfeld[y][x] == 3)) {
							getSpielfeld()[y][x] = 1;
							gegnerAnzahl++;
						} else
							x--;
					}
			}
	}

	private void set_HeldPostition() {
		if (spielfeld[pos_y][pos_x] == 1) {
			return;
		}

		if (spielfeld[pos_y][pos_x] == 2) {
			spielfeld = new int[spielfeld.length][spielfeld[0].length];
			setScore(getScore() + 1);
			spielFeldAufbauen();
		}
		spielfeld[pos_y][pos_x] = 3;

	}

	private void unset_AlteHeldPosition(int y, int x) {
		spielfeld[y][x] = 0;
	}

	public void setPfad_zu_SpielfeldBild(String pfad_zu_SpielfeldBild) {
		this.pfad_zu_SpielfeldBild = pfad_zu_SpielfeldBild;
	}

	public String getPfad_zu_SpielfeldBild() {
		return pfad_zu_SpielfeldBild;
	}

	public void setPfad_zu_GegnerBild(String pfad_zu_GegnerBild) {
		this.pfad_zu_GegnerBild = pfad_zu_GegnerBild;
	}

	public String getPfad_zu_GegnerBild() {
		return pfad_zu_GegnerBild;
	}

	public void setPfad_zu_SchatzBild(String pfad_zu_SchatzBild) {
		this.pfad_zu_SchatzBild = pfad_zu_SchatzBild;
	}

	public String getPfad_zu_SchatzBild() {
		return pfad_zu_SchatzBild;
	}

	public void setSpielfeld(int[][] spielfeld) {
		this.spielfeld = spielfeld;
	}

	public int[][] getSpielfeld() {
		return spielfeld;
	}

	public void setPfad_zu_HeldBild(String pfad_zu_HeldBild) {
		this.pfad_zu_HeldBild = pfad_zu_HeldBild;
	}

	public String getPfad_zu_HeldBild() {
		return pfad_zu_HeldBild;
	}

	public void setScore(int score) {
		this.score = score;
	}

	public int getScore() {
		return score;
	}

}
